//+------------------------------------------------------------------+
//|                                         Translator positions.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
input string subfolder="MetaTrader 4";//     Files 5    4
int cnt_command=1;
int  TotalSymbols;
string Symbols[];    //  
double SymPosVol[];  //     
int    SymPosType[]; //   ,    -1
double SymPosSL[];   //  SL ,    SL    0
double SymPosTP[];   //  TP ,    TP    0
                     //  
double prevSymPosVol[];  //       
int    prevSymPosType[]; //     ,    -1
double prevSymPosSL[];   //    SL ,    SL    0
double prevSymPosTP[];   //    TP ,    TP    0
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---     MarketWatch   
   TotalSymbols=SymbolsTotal(true); // true     MarketWatch
//---       
   ArrayResize(Symbols,TotalSymbols);
//---          
   ArrayResize(SymPosVol,TotalSymbols);
   ArrayInitialize(SymPosVol,0.0);
//---           
   ArrayResize(SymPosType,TotalSymbols);
   ArrayInitialize(SymPosType,-1);
//---       
   ArrayResize(SymPosSL,TotalSymbols);
   ArrayInitialize(SymPosSL,0.0);
//---          
   ArrayResize(SymPosTP,TotalSymbols);
   ArrayInitialize(SymPosTP,0.0);
//---       
   ArrayResize(prevSymPosVol,TotalSymbols);
   ArrayResize(prevSymPosType,TotalSymbols);
   ArrayResize(prevSymPosSL,TotalSymbols);
   ArrayResize(prevSymPosTP,TotalSymbols);
//---     MarketWatch
   for(int i=0;i<TotalSymbols;i++)
      Symbols[i]=SymbolName(i,true); //i    // true     MarketWatch

//---     1 .
   EventSetTimer(1);
//--- 
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---  
   Comment("");
//---     
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---   
   get_positions();
//---        
   if(compare_positions())saves_positions();
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void get_positions()
  {
//---      
   for(int i=0;i<TotalSymbols;i++)
     {
      //---             
      if(PositionSelect(Symbols[i]))
        {
         //---            
         SymPosVol[i]=(double)PositionGetDouble(POSITION_VOLUME);
         //---     
         SymPosType[i]=(int)PositionGetInteger(POSITION_TYPE);
         //---     
         SymPosSL[i]=(double)PositionGetDouble(POSITION_SL);
         //---     
         SymPosTP[i]=(double)PositionGetDouble(POSITION_TP);
        }
      //---              
      else {SymPosVol[i]=0.0; SymPosType[i]=-1;SymPosSL[i]=0.0;SymPosTP[i]=0.0;}
     }
  }
//+------------------------------------------------------------------+
//|                                                   |
//|  true         |
//+------------------------------------------------------------------+
bool compare_positions()
  {
//---        
   for(int i=0;i<TotalSymbols;i++)
     {
      //---     
      if(prevSymPosVol[i]!=SymPosVol[i])return(true);
      //---    
      if(prevSymPosType[i]!=SymPosType[i])return(true);
      //---     
      if(prevSymPosSL[i]!=SymPosSL[i])return(true);
      //---     
      if(prevSymPosTP[i]!=SymPosTP[i])return(true);
     }
//---         
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void saves_positions()
  {
//---       
   for(int i=0;i<TotalSymbols;i++)
     {
      //---   
      prevSymPosVol[i]=SymPosVol[i];
      //---   
      prevSymPosType[i]=SymPosType[i];
      //---   
      prevSymPosSL[i]=SymPosSL[i];
      //---   
      prevSymPosTP[i]=SymPosTP[i];
     }
//---      
   WriteFile();
  }
//+------------------------------------------------------------------+
//|           |
//+------------------------------------------------------------------+
int DigitsStepLot(string symbol)
  {
//--- 1/x   
   double Dig=1.0/SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
   int res=0;
//---   1/x  digits
   if(Dig>1)res=1;
   if(Dig>10)res=2;
   if(Dig>100)res=3;
   if(Dig>1000)res=4;
   return(res);
  }
//+------------------------------------------------------------------+
//|      csv                              |
//+------------------------------------------------------------------+
void WriteFile(string folder="Translator positions")
  {
//---    ,      
   int han=FileOpen(subfolder+"\\experts\\files\\"+folder+".csv",FILE_WRITE|FILE_SHARE_READ|FILE_ANSI,",");
   if(han!=INVALID_HANDLE)//    
     {
      string com=""; //    
      FileWrite(han,(string)cnt_command); cnt_command++;
      for(int i=0;i<TotalSymbols;i++)
        {
         //---          Symbols[i]
         FileWrite(han,
                   //---  
                   Symbols[i],
                   //---  
                   DoubleToString(prevSymPosVol[i],DigitsStepLot(Symbols[i])),
                   //---  
                   (string)prevSymPosType[i],
                   //---  
                   DoubleToString(prevSymPosSL[i],(int)SymbolInfoInteger(Symbols[i],SYMBOL_DIGITS)),
                   //---  
                   DoubleToString(prevSymPosTP[i],(int)SymbolInfoInteger(Symbols[i],SYMBOL_DIGITS))
                   );
         //---    ,       Symbols[i]
         com=com+"\n"+
             //---  
             Symbols[i]+"  [ "+
             //---  
             DoubleToString(prevSymPosVol[i],DigitsStepLot(Symbols[i]))+" ]  [ "+
             //---  
             (string)prevSymPosType[i]+" ]  [ "+
             //---  
             DoubleToString(prevSymPosSL[i],(int)SymbolInfoInteger(Symbols[i],SYMBOL_DIGITS))+" ]  [ "+
             //---  
             DoubleToString(prevSymPosTP[i],(int)SymbolInfoInteger(Symbols[i],SYMBOL_DIGITS))+" ]"
             ;
        }
      //---          
      FileClose(han);
      //---   
      Comment((string)(cnt_command-1),com);
     }
//---       
   else Print("File open failed"+subfolder+"\\"+folder+".csv, error",GetLastError());
  }
//+------------------------------------------------------------------+
